<?php

namespace Teknisa\DF\Modules\Entrada\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;


class ProdutoComProdutosxml extends \Teknisa\DF\Controllers\TeknisaCrud {
    protected $dataSourceName = 'produto_comprodutosxmls';
    protected $parameterBagColumns = array('CDFORNECED');
    protected $Dfe52000Service;
    protected $environment;

    public function __construct($crudService, $parameterBag, $Dfe52000RelacionamentoProdutoXProduto, $environment) {
        parent::__construct($crudService, $parameterBag);
        $this->Dfe52000Service = $Dfe52000RelacionamentoProdutoXProduto;
        $this->environment = $environment;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $filialFranqueadora = $this->Dfe52000Service->getFranqueadora();
        $this->parameterBagColumns[] = 'P_FRANQUEADORA';
        if($filialFranqueadora) {
            $franqueadora = ( $filialFranqueadora == $this->environment->getCdfilial()) ? 'S' : 'N';
        }
        else {
            $franqueadora = 'N';
        }
        $this->dataSourceName = 'produto_comprodutosxmls';
        
        parent::find($request, $response);
        $request->getFilterCriteria()->addCondition("P_FRANQUEADORA", "=", $franqueadora);
    }
    
     public function findReplic(DTO\Request\Filter $request, DTO\Response $response) {
        $filialFranqueadora = $this->Dfe52000Service->getFranqueadora();
        $this->parameterBagColumns[] = 'P_FRANQUEADORA';
        if($filialFranqueadora) {
            $franqueadora = ( $filialFranqueadora == $this->environment->getCdfilial()) ? 'S' : 'N';
        }
        else {
            $franqueadora = 'N';
        }
        $this->dataSourceName = 'replic_produto_comprodutosxmls';
        
        parent::find($request, $response);
        $request->getFilterCriteria()->addCondition("P_FRANQUEADORA", "=", $franqueadora);
    }
    
    public function filialFranqueadora(DTO\Request\Filter $request, DTO\Response $response) {
        $filialFranqueadora = $this->Dfe52000Service->getFranqueadora();
        if($filialFranqueadora) {
            $franqueadora = ( $filialFranqueadora == $this->environment->getCdfilial());
            $response->addDataSet(new DataSet('filial_franqueadora', array('EXISTE_FRANQUEADORA' => true, 'FRANQUEADORA' => $franqueadora)));
        }
        else {
            $response->addDataSet(new DataSet('filial_franqueadora', array('EXISTE_FRANQUEADORA' => false, 'FRANQUEADORA' => false)));
        }
    }
    
    public function findFilial(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = 'produto_comprodutosxmls_filial';
        $this->parameterBagColumns[] = "CDFILIAL";
        parent::find($request, $response);
    }
    
    public function findReplicFilial(DTO\Request\Filter $request, DTO\Response $response) {
        var_dump("oi");
        $this->dataSourceName = 'replic_produto_comprodutosxmls_filial';
        //$this->parameterBagColumns[] = "CDFILIAL";
        parent::find($request, $response);
    }
    
    public function saveFilial(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = 'produto_comprodutosxmls_filial';
        $this->save($request, $response);
    }
     
    public function deleteFilial(DTO\Request  $request, DTO\Response $response) {
        $this->dataSourceName = 'produto_comprodutosxmls_filial';
        parent::delete($request, $response);
    }

    public function save(DTO\Request $request, DTO\Response $response) {
        $dataSet = $request->getDataSet();
        $rows = $dataSet->getRows();
        $row  = $rows[0];
        
        if ($this->dataSourceName == 'produto_comprodutosxmls') {
            $row['CDFILIAL'] = 0;
        }

        try {
            if(!$row['__is_new']) {
                $this->Dfe52000Service->editRow($row['OLDCDPRODUTOXML'], $row['OLDCDPRODUTO'], $row['CDFORNECED'],$row['CDPRODUTO'],$row['NRORG'],$row['CDPRODUTOXML'],$row['NMPRODUTOXML'],$row['VRFATCONVOL'], $row['CDFILIAL'], $this->dataSourceName);
            } else {
                $this->Dfe52000Service->checaProdutoXMLExistente($row['CDPRODUTOXML'], $row['CDFORNECED'] ,$row['CDPRODUTO'], $row['CDFILIAL'], $this->dataSourceName);
                parent::save($request, $response);  
            }
            
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
    
    public function saveReplic(DTO\Request $request, DTO\Response $response) {
        $dataSet = $request->getDataSet();
        $rows = $dataSet->getRows();
        $row  = $rows[0];
        try {
            
            if($row["TNRINSJURFORN"] === "T") {
                $allFornecedor = $this->Dfe52000Service->getAllFornecedor($row["NMRAZSOCFORNORIG"]);

                forEach($allFornecedor as $cdforneced) {
            
                    $row["CDFORNECED"]  =  $cdforneced["CDFORNECED"];
                    $this->dataSourceName = 'replic_produto_comprodutosxmls';
                    parent::save($request, $response);
                          
                }
                
            } else {
                if(is_array($row['CDFORNECED'])) {
                    $fornecedores = $row['CDFORNECED'];
                    forEach($fornecedores as $cdfornecedor) {
                        $row['CDFORNECED']  = $cdfornecedor; 
                        //$this->Dfe52000Service->checaProdutoXMLExistente($row['CDPRODUTOXML'], $row['CDFORNECED'] ,$row['CDPRODUTO'], $row['CDFILIAL'], $this->dataSourceName);
                        $this->dataSourceName = 'replic_produto_comprodutosxmls';
                        parent::save($request, $response);  
                    } 
                    
                } else {
                    $this->dataSourceName = 'replic_produto_comprodutosxmls';
                    //$this->Dfe52000Service->checaProdutoXMLExistente($row['CDPRODUTOXML'], $row['CDFORNECED'] ,$row['CDPRODUTO'], $row['CDFILIAL'], $this->dataSourceName);
                    parent::save($request, $response);  
                }
            }
            
        } catch (\Exception $e) {
            $response->addMessage(new Response\Message($e->getMessage(), Response\Message::TYPE_ERROR));
        }
    }
    
    public function saveReplicFilial(DTO\Request $request, DTO\Response $response) {
        $dataSet = $request->getDataSet();
        $rows = $dataSet->getRows();
        $row  = $rows[0];
        
        try {
            
            if($row["TNRINSJURFORN"] === "T") {
                $allFornecedor = $this->Dfe52000Service->getAllFornecedor($row["NMRAZSOCFORNORIG"]);
                
                forEach($allFornecedor as $cdforneced) {
                    $row["CDFORNECED"]  =  $cdforneced["CDFORNECED"];
                    //$this->Dfe52000Service->checaProdutoXMLExistente($row['CDPRODUTOXML'], $row['CDFORNECED'] ,$row['CDPRODUTO'], $row['CDFILIAL'], $this->dataSourceName);
                    $this->dataSourceName = 'replic_produto_comprodutosxmls_filial';
                    parent::save($request, $response);
                }   
                  
            } else {
                if(is_array($row['CDFORNECED'])) {
                    $fornecedores = $row['CDFORNECED'];
                    
                    forEach($fornecedores as $cdfornecedor) {
                        $row['CDFORNECED']  = $cdfornecedor; 
                        //$this->Dfe52000Service->checaProdutoXMLExistente($row['CDPRODUTOXML'], $row['CDFORNECED'] ,$row['CDPRODUTO'], $row['CDFILIAL'], $this->dataSourceName);
                        $this->dataSourceName = 'replic_produto_comprodutosxmls_filial';
                        parent::save($request, $response);  
                    } 
                    
                } else {
                    $this->dataSourceName = 'replic_produto_comprodutosxmls_filial';
                    //$this->Dfe52000Service->checaProdutoXMLExistente($row['CDPRODUTOXML'], $row['CDFORNECED'] ,$row['CDPRODUTO'], $row['CDFILIAL'], $this->dataSourceName);
                    parent::save($request, $response);  
                }
            }
            
        } catch (\Exception $e) {
            $response->addMessage(new Response\Message($e->getMessage(), Response\Message::TYPE_ERROR));
        }
    }
    
}